// Bacasable11_7Stereo.pde
// Gerard Paresys Guykayser
// 12 09 2024 
//
// = modif de Bacasable11_6Stereo.pde
// Ajout 12 9 2024 DecalCarre
// En mode 6 voix, tire au hasard, au lancement, 6 voix parmi les 10 premieres de TableNomFichier
//
// OK Processing 2.2.1 MacOSX.10
// NON Processing 3
// OK Kinect 1414 (original kinect)
//
// Utilise la "contributed library" SimpleOpenNI Version 1.96 by Max Rheiner
// "Processing Wrapper for the OpenNI/Kinect library"
// http://code.google.com/p/simple-openni
// http://iad.zhdk.ch/
//
// N'utilise pas la "contributed library" peasycam by Jonathan Feinberg
//
// Utilise la library minim incluse dans Processing 2
// http://code.compartmental.net/minim/
//
// cf Processing/libraries/SimpleOpenNI/examples/OpenNI/DepthImage/DepthImage.pde
//
// Touche Clavier:  keyPressed()
//   D Image Depth  Palette 256 brightness  (Defaut)
//   1 Palette 256  Noir -> Rouge
//   3 Palette 256  Noir -> Bleu -> Blanc -> Jaune -> Orange
//   5 Palette 256  Noir -> Blanc
//   7 Palette 256 Rouge -> Blanc (Palette "Labomedia" claire)
//   9 Palette 256  Noir -> Rose  (Palette "Labomedia" sombre)
//   0 Palette 256 Rouge -> Rose  (Palette "Labomedia" ...)
//   G Inversion des palettes 256
//   E Image Depth  Palette en mm
//   C Couleur pour Palette mm
//   I Image InfraRed
//   H Image HeightMap
//   V Visu Nom des fichiers + 6 Mesures des 12 zones:
//       AccTrans  Accumulation pixel couche haute Transcription
//       AccMot    Accumulation pixel couche       Mot
//       AccSyllab Accumulation pixel couche       Syllabe
//       AccPhon   Accumulation pixel couche basse Phoneme
//       Acc = AccTrans + AccMot + AccSyllab + AccPhon
//       Maxi = 1 ou 2 ou 3 ou 4
//   Y Inverser Couche
//   N Miroir IR
//   Z Zoom
//   B Blur
//   6 Blur +
//   4 Blur -
//   8 Lumiere +
//   2 Lumiere -
//   Fleche Up    + 1 pixel dY
//   Fleche Down  - 1 pixel dY
//   Fleche Left  - 1 pixel dX
//   Fleche Right + 1 pixel dX
//   S Sauve l'ecran (format png) dans le dossier du sketch (nombre = Numero frame)
//
//  A faire:
//    Supprimer peasy   inutile?
//    Supprimer AccRien inutile?
//    Supprimer Verdana inutile?
//    Supprimer void LecteurFragmentAudio
//    Touche N Miroir IR fait planter

import SimpleOpenNI.*;      // pour Kinect
// import peasy.*;
import ddf.minim.*;         // pour AudioPlayer

boolean FlagKinect = true; // Mettre false en l'absence de kinect
boolean PleinEcran = true; // true or false
int NVoix = 6; // 6 ou 12
// 12 Voix: zone utile de l'ecran: 145+145+145+145 x 145+145+145 = 580 x 435
//  6 Voix: zone utile de l'ecran:     194+194+194 x     218+218 = 582 x 436
int DecalCarre = 20; // En pixels, en X et Y,  0 ..  80 Limite la zone d'Acc umulation

//boolean FlagPeasyCam = false;
boolean Miroir = false; 
String Image = "E"; // D 12/9/2024
int Palette = 5;
Boolean Zoom = false;
Boolean Couleur = false;
Boolean Blur = true;
int QBlur = 35;
Boolean Visu = false;
Boolean CoucheInverse = false;
boolean Verbose = false;
int Fragment = 2; // 1:Transcription 2:Mot 3:Syllabe 4:Phoneme 
int Seuil = 100; // 279
Boolean Sauve = false;
int SeuilBouge = 3;
int Latence = 12000; // Temps latence du declenchement des voix en ms 

// int TailleCarre640 = 145; // = 232 * 640 / 1024
int TailleCarreX640; // = 232 * 640 / 1024
int TailleCarreY640; 

// int TailleCarre; 
int TailleCarreX; 
int TailleCarreY; 

int Seuil1 = 1050; // 1070 12 voix
int Seuil2 = 1030; // 1030 1025 12 voix
int Seuil3 = 1010; // 1010 1000
int Seuil4 = 990;  // 990 965
int Seuil5 = 970;  // 970 930
int NbrBougeVoixMax = 5;
int NbrBougeVoix = 0;
int NbrAudioPlay = 0;
int NbrAudioPlayMax = 1;

int x1 = 0, y1 = 0, x2 = 640, y2 = 480; 
float b;

SimpleOpenNI  Kinect;

PImage Image1, Image2;
PImage Pseudo;

int TailleX = 320, TailleY = 240, TailleXdemi = 160, TailleYdemi = 120;
float[][] hm  = new float[TailleX][TailleY]; // hm[x][y] = brightness(Image)
float[][] hm2 = new float[TailleX][TailleY];

//PeasyCam pcam;
//CameraState  pcamstate;

int[] depthMap = new int[640*480];
int index;
float Facteur = 10;
float Delta = 0;

int[] Palette256; 
int[] Palettemm; 

int Voix = 0; // 0..11 ou 0..5
int[] Acc  = new int[NVoix];
int[] AccAvant = { 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};
boolean[] Bouge = { 
  false, false, false, false, false, false, false, false, false, false, false, false
};
int[] TempsLatence = { 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

int[] AccTrans  = new int[NVoix];
int[] AccMot    = new int[NVoix];
int[] AccSyllab = new int[NVoix];
int[] AccPhon   = new int[NVoix];
int[] AccRien   = new int[NVoix];

int[] Maxi      = new int[NVoix]; // Maxi = 1:Transcription 2:Mot 3:Syllabe 4:Phoneme
int[] Segment = { 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

String ExtensionFichierAudio = ".wav"; // ".wav" ".mp3"
String Content1 = "", Content2 = "", Content = "";
String[] TableNomFichier = {
  "ESLO1_ENT_110.xml", 
  "ESLO1_INTPERS_423.xml", 
  "ESLO1_INTPERS_439.xml", 
  "ESLO2_CONF_1243.xml", 
  "ESLO2_DIA_1227.xml", 
  "ESLO2_ENT_1012.xml", 
  "ESLO2_ENT_1027.xml", 
  "ESLO2_ENT_1028.xml", 
  "ESLO2_ENT_1049.xml", 
  "ESLO2_ENT_1076.xml", 
  "ESLO2_REPAS_1270.xml", 
  "ESLO1_ENT_010.xml"
}; 
String NomFichierXML = TableNomFichier[0]; //

XML[][] XMLTranscription = new XML[NVoix][200];
XML[][] XMLPhoneme       = new XML[NVoix][200];
XML[][] XMLMot           = new XML[NVoix][200];
XML[][] XMLSyllabe       = new XML[NVoix][200];

int[] NbrTranscription = new int[NVoix];
int[] NbrPhoneme       = new int[NVoix];
int[] NbrMot           = new int[NVoix];
int[] NbrSyllabe       = new int[NVoix];


Minim minim;
// AudioPlayer player;
AudioPlayer[] LecteurAudio = new AudioPlayer[NVoix];
float xmin, xmax;  // Temps en seconde
int TempsVoix[] = {
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
}; //ms
int DelaiPhonemeSyllabe = 100; // ms

boolean[] FichierOuvert = {
  false, false, false, false, false, false, false, false, false, false, false, false, false
};
int IndexXML = 0;
float Temps, TempsPause = 0, TempsDebutPause = 0;
// int ZoneMaxAvant = 0, ZoneMax = 0, Max = 0;
String S = "";
int i = 0;
int Dx1 = 0, Dy1 = 0;
int Colonne;
PFont maFonte;
Urn urne;
String[] nomVoix = new String[NVoix];

void setup() {
  // size(640, 480, P3D);
  // size(1280, 960, P3D);
  if (PleinEcran) size(displayWidth, displayHeight, P3D);
  // else size(640, 480, P3D);
  else size(1024, 768, P3D);
  println("Ecran " + width + "x" + height);
  x2 = width;
  y2 = height;
  if (NVoix == 6) TailleCarreX640 = 194; 
  else TailleCarreX640 = 145;
  if (NVoix == 6) TailleCarreY640 = 218; 
  else TailleCarreY640 = 145;

  // TailleCarre = TailleCarre640 * width / 640;
  TailleCarreX = TailleCarreX640 * width / 640;
  TailleCarreY = TailleCarreY640 * height / 480;

  frameRate(20);


  Pseudo = loadImage("PseudoImage.png"); // Image 640 x 480 en l'absence de Kinect

  if (FlagKinect) {
    Kinect = new SimpleOpenNI(this);
    if (Kinect.isInit() == false) {
      println("Can't init SimpleOpenNI, maybe the Kinect is not connected!"); 
      exit();
      return;
    }
    Kinect.setMirror(Miroir);
    Kinect.enableDepth();
    // Kinect.enableRGB();
    Kinect.enableIR(); // IR is only available if there is no RGBImage activated at the same time
    // Kinect.enableUser();
    // Kinect.alternativeViewPointDepthToImage();
    // Kinect.setDepthColorSyncEnabled(true);
    println("Kinect.depthWidth() = " + Kinect.depthWidth() + "    Kinect.depthHeight() = " + Kinect.depthHeight());
  } else println("setup FlagKinect = " + FlagKinect);

  //  if (FlagPeasyCam) {
  //    pcam = new PeasyCam(this, width/2, height/2, 0, 300); // PeasyCam(PApplet parent, double lookAtX, double lookAtY, double lookAtZ, double distance);
  //    pcam.setMinimumDistance(50);
  //    pcam.setMaximumDistance(1000);
  //    pcam.rotateX(-PI/8);
  //    pcamstate = pcam.getState();
  //  }

  Palette256 = new int[256];
  CalculPalette256(Palette);

  Palettemm = new int[1070];
  for (int i=0; i<1070; i++) {
    if (i > 1060)      Palettemm[i] = color(0, 0, 80);  
    else if (i > 1040) Palettemm[i] = color(0, 50, 102);  
    else if (i > 1020) Palettemm[i] = color(0, 97, 71);// color(150, 150, 0);  
    else if (i > 1000)  Palettemm[i] = color(0, 200, 0); // color(200, 200, 0);  
    else if (i > 980)  Palettemm[i] = color(150, 150, 0); //color(0, 97, 71); // color(16, 122, 47);  
    else if (i > 960)  Palettemm[i] = color(200, 200, 0); // color(0, 255, 0); // color(16, 122, 47);  
    else if (i > 940)  Palettemm[i] = color(161, 67, 0);  
    else if (i > 920)  Palettemm[i] = color(130, 30, 30);  
    else if (i > 900)  Palettemm[i] = color(255, 20, 0);
  }

  //  File Fichier = new File(dataPath(NomFichierXML));
  //  if (Fichier.exists()) {
  //    Ouverture(NomFichierXML);
  //    // Nom = split(Fichier.getName(), '.')[0];
  //  } else selectInput("select the XML File (format Praat textGrid):", "SelectionFichier");

  if (NVoix == 6) Colonne = 3;
  else Colonne = 4;

  minim = new Minim(this);
  if (NVoix == 6) urne = new Urn(10);
  else urne = new Urn(12);
  // for (Voix = 0; Voix < NVoix; Voix++) Ouverture(TableNomFichier[Voix], Voix);
  for (Voix = 0; Voix < NVoix; Voix++) Ouverture(TableNomFichier[urne.update()], Voix);

  // maFonte = loadFont("Verdana-48.vlw");    
  maFonte = loadFont("OpenSans-14.vlw"); // mieux que Verdana  
  textFont(maFonte);
  if (!FlagKinect){
    Seuil1 = 107;
    Seuil2 = 103;
    Seuil3 = 100;
    Seuil4 = 96;
    Seuil5 = 93;
  }
  noCursor();
}

void draw() {
  // background(0);  // 

  //  if (Blur) {
  //    noStroke();
  //    fill(0, QBlur); // semi-transparent black
  //    rect(0, 0, width, height);
  //  } 
  //  else background(0);

  if (FlagKinect) {
    Kinect.update();
    Image1 = Kinect.depthImage();
    Image2 = Image1;
    depthMap = Kinect.depthMap(); // depthMap en mm
    if (Image.equals("H")) {
      Calculhm();
      pushMatrix();
      translate(width/2, height/2);
      paintLandscape();
      popMatrix();
    } else {
      if (Image.equals("D")) {           // Defaut
        for (int i = 0; i < (Image1.width * Image1.height); i++) {
          b = brightness(Image1.pixels[i]) * Facteur / 10;
          b = max(min(b, 255), 0);
          Image1.pixels[i] = Palette256[int(b)];
        }
      }
      if (Image.equals("E")) {
        if (Couleur) {
          for (int i = 0; i < (Image1.width * Image1.height); i++) {
            b = depthMap[i] + Delta;
            b = max(min(b, 1069), 0);
            Image1.pixels[i] = Palettemm[int(b)];
          }
        } else {
          for (int i = 0; i < (Image1.width * Image1.height); i++) {
            b = depthMap[i]  + Delta;
            // b = (b - 970) / 200 * 256; // 870 12/9/2024
            b = (1150 - b) / 200 * 256; // 870 12/9/2024
            b = max(min(b, 255), 0);
            Image1.pixels[i] = color(b);
          }
        }
      }
      // if (Image.equals("R")) image(Kinect.rgbImage(), x1, y1, x2, y2);
      if (Image.equals("I")) Image1 = Kinect.irImage();
      Image1.updatePixels();
    }
  } else {
    Image1 = Pseudo;
    for (int i = 0; i < (Image1.width * Image1.height); i++) depthMap[i] = int(red(Image1.pixels[i]));
    // for (int i = 1; i < 20; i++) println(depthMap[i + 5000] + "  ");
  }

  if (Blur) tint(255, QBlur); // Apply transparency without changing color
  else noTint(); 
  // image(Image1, x1, y1, x2, y2);
  image(Image1, x1 + Dx1, y1 + Dy1, x2, y2);

  // Mesure 4 x 3 carres TailleCarre x TailleCarre = 145 x 145
  if (FlagKinect) Image1 = Image2; 
  else Image1 = Pseudo;
  // Image1.updatePixels();
  // Image1.loadPixels();

  textAlign(CENTER); // textAlign(CENTER, CENTER); //RIGHT LEFT BOTTOM BASELINE TOP
  textSize(16);
  NbrBougeVoix = 0;

  for (Voix = 0; Voix < NVoix; Voix++) {
    // Acc[Voix]       = 0;
    AccTrans[Voix]  = 0;
    AccMot[Voix]    = 0;
    AccSyllab[Voix] = 0;
    AccPhon[Voix]   = 0;
    AccRien[Voix]   = 0;
    //  int Decalage = (320 - 2 * TailleCarre640) + ((Voix % 4) * TailleCarre640) + ((480 - (3 * TailleCarre640) + ((Voix / 4) * TailleCarre640)) * 640);
    int Decalage;
    if (NVoix == 6) Decalage = (320 - (Colonne * TailleCarreX640) / 2) + ((Voix % Colonne) * TailleCarreX640) + ((480 - (2 * TailleCarreY640) + ((Voix / Colonne) * TailleCarreY640)) * 640);
    else Decalage = (320 - (Colonne * TailleCarreX640) / 2) + ((Voix % Colonne) * TailleCarreX640) + ((480 - (3 * TailleCarreY640) + ((Voix / Colonne) * TailleCarreY640)) * 640);
    // println("Decalage = " +  Decalage + "   TailleCarreX640 = " + TailleCarreX640 + "   TailleCarreY640 = " + TailleCarreY640);
    for (int u = DecalCarre; u < TailleCarreX640 - DecalCarre; u++) {
      for (int v = DecalCarre; v < TailleCarreY640 - DecalCarre; v++) {
        // Acc[Voix] = Acc[Voix] + int(brightness(Image1.pixels[u + (v * 640) + Decalage]));
        int i = depthMap[u + (v * 640) + Decalage];
        // Acc[Voix] = Acc[Voix] + i;
        if (CoucheInverse) {
          if (i > Seuil1) ;
          else if (i > Seuil2) AccTrans[Voix]   = AccTrans[Voix]   + i; // 1 au lieu de i ?
          else if (i > Seuil3) AccMot[Voix] = AccMot[Voix] + i; // 1 au lieu de i ?
          else if (i > Seuil4) AccSyllab[Voix] = AccSyllab[Voix]    + i; // 1 au lieu de i ?
          else if (i > Seuil5) AccPhon[Voix]  = AccPhon[Voix]  + i; // 1 au lieu de i ?
          else AccRien[Voix] = AccRien[Voix] + i; // 1 au lieu de i ?
        } else {
          if (i > Seuil1) ;
          else if (i > Seuil2) AccPhon[Voix]   = AccPhon[Voix]   + i; // 1 au lieu de i ?
          else if (i > Seuil3) AccSyllab[Voix] = AccSyllab[Voix] + i; // 1 au lieu de i ?
          else if (i > Seuil4) AccMot[Voix]    = AccMot[Voix]    + i; // 1 au lieu de i ?
          else if (i > Seuil5) AccTrans[Voix]  = AccTrans[Voix]  + i; // 1 au lieu de i ?
          else AccRien[Voix] = AccRien[Voix] + i; // 1 au lieu de i ?
        }
      }
    }
    AccTrans[Voix]  = AccTrans[Voix]  / 100000; // 100 au lieu de 100000 ?
    AccMot[Voix]    = AccMot[Voix]    / 100000; // 100 au lieu de 100000 ?
    AccSyllab[Voix] = AccSyllab[Voix] / 100000; // 100 au lieu de 100000 ?
    AccPhon[Voix]   = AccPhon[Voix]   / 100000; // 100 au lieu de 100000 ?
    AccRien[Voix]   = AccRien[Voix]   / 100000; // 100 au lieu de 100000 ?
    Acc[Voix] = AccTrans[Voix] + AccMot[Voix] + AccSyllab[Voix] + AccPhon[Voix];

    Bouge[Voix] = ((Acc[Voix] > AccAvant[Voix] + SeuilBouge) || (Acc[Voix] < AccAvant[Voix] - SeuilBouge));
    if (!FlagKinect) Bouge[Voix] = (random(10) > 9) ;  // 
    if (Bouge[Voix]) {
      frameRate(20);
      NbrBougeVoix = NbrBougeVoix + 1;
      TempsLatence[Voix] = millis() + Latence ;
    } else {
     frameRate(15); 
    }
    Maxi[Voix] = 1;
    int AccMaxi = AccTrans[Voix];
    if (AccMot[Voix] > AccMaxi) {
      Maxi[Voix] = 2; 
      AccMaxi = AccMot[Voix];
    }
    if (AccSyllab[Voix] > AccMaxi) {
      Maxi[Voix] = 3; 
      AccMaxi = AccSyllab[Voix];
    }
    if (AccPhon[Voix] > AccMaxi) {
      Maxi[Voix] = 4; 
      AccMaxi = AccPhon[Voix];
    }

    if (Visu) {
      fill(0, 255, 0);  // Rouge
      text(AccTrans[Voix], TextX(Voix % Colonne), TextY(Voix / Colonne) + 10);
      text(AccMot[Voix], TextX(Voix % Colonne), TextY(Voix / Colonne) + 30);
      text(AccSyllab[Voix], TextX(Voix % Colonne), TextY(Voix / Colonne) + 50);
      text(AccPhon[Voix], TextX(Voix % Colonne), TextY(Voix / Colonne) + 70);
      text(Acc[Voix], TextX(Voix % Colonne), TextY(Voix / Colonne) + 90);
      text(AccRien[Voix], TextX(Voix % Colonne), TextY(Voix / Colonne) + 110);
      
      text(Maxi[Voix], TextX(Voix % Colonne), TextY(Voix / Colonne) + 130);
    }    

    AccAvant[Voix] = Acc[Voix];
  }
  // println("NbrBougeVoix = " + NbrBougeVoix);

  //  ZoneMax = 0;
  //  Max = 0;
  //  for (int z = 0; z < NVoix; z++) {
  //    if (Acc[z] > Max) {
  //      Max = Acc[z];
  //      ZoneMax = z;
  //    }
  //  }
  // println("ZoneMax = " + ZoneMax);
  // if (Visu) text("ZoneMax = " + ZoneMax, width / 2, height - 20);
  //  if (ZoneMaxAvant != ZoneMax) {
  //    ZoneMaxAvant = ZoneMax;
  //    // Ouverture(TableNomFichier[ZoneMax]);
  //    // Ouverture1Fois(ZoneMax);
  //  }  

  for (Voix = 0; Voix < NVoix; Voix++) {
    if (millis() > TempsVoix[Voix]) {
      LecteurAudio[Voix].pause(); //
    }
  }

  // Voix = int(random(NVoix));  // Voix = 6;

  NbrAudioPlay = 0;
  for (Voix = 0; Voix < NVoix; Voix++) {
    if (LecteurAudio[Voix].isPlaying()) {
      NbrAudioPlay = NbrAudioPlay +1;
    }
  }

  for (Voix = 0; Voix < NVoix; Voix++) {  
    // if (Bouge[Voix]) {
    Fragment = Maxi[Voix];
    if (Fragment > 2) DelaiPhonemeSyllabe = int(random(100, 400)); 
    else DelaiPhonemeSyllabe = 0; // 0 12 9 2024

    if (millis() > TempsVoix[Voix] + DelaiPhonemeSyllabe) {
      if (Fragment == 1) { // Transcription
        // i = int(random(NbrTranscription[Voix]));
        S = XMLTranscription[Voix][Segment[Voix]].getContent();
        xmin = XMLTranscription[Voix][Segment[Voix]].getFloat("xmin");// Temps en seconde
        xmax = XMLTranscription[Voix][Segment[Voix]].getFloat("xmax");// Temps en seconde
        // println("Voix = " + Voix + "   Segment[Voix] = " + Segment[Voix]);
        Segment[Voix] = Segment[Voix] + 1;
        if (Segment[Voix] > NbrTranscription[Voix] - 1) Segment[Voix] = 0;
      } else if (Fragment == 2) { // Mot
        i = int(random(NbrMot[Voix]));
        S = XMLMot[Voix][i].getContent();
        xmin = XMLMot[Voix][i].getFloat("xmin");// Temps en seconde
        xmax = XMLMot[Voix][i].getFloat("xmax");// Temps en seconde
      } else if (Fragment == 3) { // Syllabe
        i = int(random(NbrSyllabe[Voix]));
        S = XMLSyllabe[Voix][i].getContent();
        xmin = XMLSyllabe[Voix][i].getFloat("xmin");// Temps en seconde
        xmax = XMLSyllabe[Voix][i].getFloat("xmax");// Temps en seconde
      } else if (Fragment == 4) { // Phoneme
        i = int(random(NbrPhoneme[Voix]));
        S = XMLPhoneme[Voix][i].getContent();
        xmin = XMLPhoneme[Voix][i].getFloat("xmin");// Temps en seconde
        xmax = XMLPhoneme[Voix][i].getFloat("xmax");// Temps en seconde
      }

      if (millis() < TempsLatence[Voix]) {
        // if (millis() > TempsVoix[Voix] + DelaiPhonemeSyllabe) {
        if (NbrAudioPlay < NbrAudioPlayMax) {
          LecteurAudio[Voix].play(int(xmin * 1000));
          // println("Frame = " + frameCount + "  millis = " + millis() + "  TempsVoix[Voix] = " + TempsVoix[Voix] + "  Voix = " + Voix + "   i = " + i + "   S = " + S +"  min = " + int(xmin * 1000) +"  max = " + int(xmax * 1000));
          TempsVoix[Voix] = millis() + int((xmax-xmin) * 1000);
        }
      }

      // if (millis() < TempsLatence[Voix]) {
      pushMatrix();
      if (CoucheInverse) { // 1:Transcription 2:Mot 3:Syllabe 4:Phoneme
        if (Fragment == 1) fill(255, 255, 255); // fill(255, 0, 0);
        else if (Fragment == 2) fill(0, 0, 0);
        else if (Fragment == 3) fill(255, 255, 255);
        else fill(255, 0, 0);
      } else {
        if (Fragment == 1) fill(150, 0, 0); // fill(255, 0, 0);
        else if (Fragment == 2) fill(0, 0, 0);
        else fill(255, 255, 255);
      }

      //      if (Fragment == 1) {
      //        if (millis() < TempsLatence[Voix]) translate(TextX(Voix % 4), TextY(Voix / 4));
      //        else {
      //          if ((Voix > 3) && (Voix < 8)) translate(TextX(Voix % 4) + random(-70, 50), TextY(Voix / 4));
      //          else translate(TextX(Voix % 4), TextY(Voix / 4) + random(-70, 50));
      //        }
      //      } else if (Fragment == 2) {
      //        if ((Voix > 3) && (Voix < 8)) translate(TextX(Voix % 4)+ random(-80, 60), TextY(Voix / 4)  );
      //        else translate(TextX(Voix % 4), TextY(Voix / 4)  + random(-80, 60));
      //      } else translate(TextX(Voix % 4) + random(-80, 60), TextY(Voix / 4) + random(-80, 60)); // Phoneme Syllabe

      if (Fragment == 1) {
        if (millis() < TempsLatence[Voix]) translate(TextX(Voix % Colonne), TextY(Voix / Colonne));
        else {
          if (NVoix == 6) {
            // translate(TextX(Voix % Colonne), TextY(Voix / Colonne) + random(-70, 50));
            translate(TextX(Voix % Colonne), TextY(Voix / Colonne) + random(-120, 120));
          } else {
            if ((Voix > 3) && (Voix < 8)) translate(TextX(Voix % Colonne) + random(-70, 50), TextY(Voix / Colonne));
            else translate(TextX(Voix % Colonne), TextY(Voix / Colonne) + random(-70, 50));
          }
        }
      } else if (Fragment == 2) {
        if (NVoix == 6) {
          translate(TextX(Voix % Colonne), TextY(Voix / Colonne)  + random(-120, 120));
        } else {
          if ((Voix > 3) && (Voix < 8)) translate(TextX(Voix % Colonne)+ random(-80, 60), TextY(Voix / Colonne)  );
          else translate(TextX(Voix % Colonne), TextY(Voix / Colonne)  + random(-80, 60));
        }
        // } else translate(TextX(Voix % Colonne) + random(-80, 60), TextY(Voix / Colonne) + random(-80, 60)); // Phoneme Syllabe
      } else translate(TextX(Voix % Colonne) + random(-120, 100), TextY(Voix / Colonne) + random(-120, 100)); // Phoneme Syllabe

      if (NVoix == 6) {
        if (Voix < 3)      rotate(PI);
        // if (Voix < 3)      rotate(PI * frameCount / 1000 );
      } else {
        if (Voix < 4)      rotate(PI);
        else if (Voix <6)  rotate(PI/2);
        else if (Voix <8)  rotate(-PI/2);
      }

      // println("Fragment = " + Fragment);
      textSize(35);
      if (Fragment == 1) { // 1:Transcription 2:Mot 3:Syllabe 4:Phoneme
        if (NVoix == 6) {
          if (Voix > 2) {
            text(S, - TailleCarreX / 2, - 40, TailleCarreX - 20, TailleCarreY - 20);
          } else {
            if (CoucheInverse) {
              text(S, - TailleCarreX / 2 + 120, 0, TailleCarreX - 20, TailleCarreY - 20);
            } else {
              text(S, - TailleCarreX / 2, 0, TailleCarreX - 20, TailleCarreY - 20);
            }
          }
        } else {
          if (Voix > 7) {
            text(S, - TailleCarreX / 2, - 40, TailleCarreX - 20, TailleCarreY - 20);
          } else if (Voix < 4) {
            if (CoucheInverse) {
              text(S, - TailleCarreX / 2 + 120, 0, TailleCarreX - 20, TailleCarreY - 20);
            } else {
              text(S, - TailleCarreX / 2, 0, TailleCarreX - 20, TailleCarreY - 20);
            }
          } else text(S, - TailleCarreX / 2, 0, TailleCarreX - 20, TailleCarreY - 20);
        }
      } else if (Fragment == 2) {
        text(S, 0, 0);
      } else {
        text(S, 0, 0);
      }
      popMatrix();
      // }
    }
  }

  // println("NbrAudioPlay = " + NbrAudioPlay);

  if (Visu) { // 4 x 3 = 12 carres rouges
    stroke(255, 0, 0); // Rouge
    strokeWeight(1);
    noFill();
    if (NVoix == 6) {
      for (int x = -1; x < 3; x++) {
        int X = width / 2 - TailleCarreX / 2 + x * TailleCarreX;
        line(X, height - 3 * TailleCarreY, X, height);
      }
    } else { 
      for (int x = -2; x < 3; x++) {
        int X = width / 2 + x * TailleCarreX;
        line(X, height - 3 * TailleCarreY, X, height);
      }
    }
    if (NVoix == 6) {
      for (int y = -2; y < 1; y++) {
        int Y = height + y * TailleCarreY;
        // line(0, Y, width, Y);
        line(width / 2 - 2  * TailleCarreX, Y, width / 2 + 2  * TailleCarreX, Y);
      }
    } else { 
      for (int y = -3; y < 1; y++) {
        int Y = height + y * TailleCarreY;
        // line(0, Y, width, Y);
        line(width / 2 - 2  * TailleCarreX, Y, width / 2 + 2  * TailleCarreX, Y);
      }
    }
    textSize(16);
    fill(255, 0, 0); 
    for (Voix = 0; Voix < NVoix; Voix++) {
      // text(TableNomFichier[Voix], TextX(Voix % 4), TextY(Voix / 4) - 30);
      //  String[] list = split(TableNomFichier[Voix], '.');
      //      if (NVoix == 6) text(list[0], TextX(Voix % 3), TextY(Voix / 3) - 30);
      //      else text(list[0], TextX(Voix % 4), TextY(Voix / 4) - 30);
      // text(list[0], TextX(Voix % Colonne), TextY(Voix / Colonne) - 30);
      text( nomVoix[Voix], TextX(Voix % Colonne), TextY(Voix / Colonne) - 30);
    }
  }
  frame.setTitle( "Kinect     " + int(10 * frameRate) / 10.0 + " fps");
  if (Sauve) {
    Sauve = false;
    saveFrame("Display-" + frameCount + ".png"); // S Sauve l'ecran
  }
}

void Calculhm1() {
  Image1 = Kinect.depthImage();
  // Image1.resize(TailleX, TailleY);
  Image1.loadPixels();
  for (int x = 0; x < TailleX; x++) {
    for (int y = 0; y < TailleY; y++) 
      hm[x][y] = max(min(brightness(Image1.pixels[(x * 2) + (y * 4 * TailleX)]) / 8.f, 100), 0);
  }
}

void Calculhm2() {
  // Voir: SimpleOpenNI/examples/OpenNI/AlternativeViewpoint3d/AlternativeViewpoint3d.pde
  //   et: SimpleOpenNI/examples/Extensions/IntersectionTest/IntersectionTest.pde
  for (int x = 0; x < TailleX; x++) {
    // for (int y = 0; y < TailleY; y++) hm[x][y] = max(min(brightness(Image1.pixels[(x*2) + ((y*2) * TailleX)])/ 8.f, 100), 0);
    for (int y = 0; y < TailleY; y++) { 
      index = (x * 2) + (y * 2 * Kinect.depthWidth());
      // hm[x][y] = depthMap[index];
      // hm[x][y] = max(min(depthMap[index]/ 40.f, 100), 0);
      hm[x][y] = max(min(depthMap[index]/ Facteur, 100), 0);
    }
  }
}

void Calculhm3() {
  // Supprimer Brightness car image en gris
  Image1 = Kinect.depthImage();
  // Image1.resize(TailleX, TailleY);
  Image1.loadPixels();
  for (int x = 0; x < TailleX; x++) {
    // for (int y = 0; y < TailleY; y++) hm[x][y] = max(min(brightness(Image1.pixels[(x*2) + ((y*2) * TailleX)])/ 8.f, 100), 0);
    for (int y = 0; y < TailleY; y++) 
      hm[x][y] = max(min(
      ( brightness(Image1.pixels[(x * 2) +     (y * 4 * TailleX)]) 
        + brightness(Image1.pixels[(x * 2) + 1 + (y * 4 * TailleX)])
        + brightness(Image1.pixels[(x * 2)     + (((y * 4) + 2 ) * TailleX)])
        + brightness(Image1.pixels[(x * 2) + 1 + (((y * 4) + 2 ) * TailleX)]))
        /  32.0, 100.0), -3.0);
  }
}

void Calculhm() {
  // Supprimer Brightness car image en gris
  Image1 = Kinect.depthImage();
  // Image1.resize(TailleX, TailleY);
  Image1.loadPixels();
  for (int x = 0; x < TailleX; x++) {
    // for (int y = 0; y < TailleY; y++) hm[x][y] = max(min(brightness(Image1.pixels[(x*2) + ((y*2) * TailleX)])/ 8.f, 100), 0);
    for (int y = 0; y < TailleY; y++) 
      hm[x][y] = min(max(max(
      brightness(Image1.pixels[(x * 2) +     (y * 4 * TailleX)]), 
      brightness(Image1.pixels[(x * 2) + 1 + (y * 4 * TailleX)]), 
      brightness(Image1.pixels[(x * 2)     + (((y * 4) + 2 ) * TailleX)])), 
      brightness(Image1.pixels[(x * 2) + 1 + (((y * 4) + 2 ) * TailleX)]))
        /  10.0, 100.0);
  }
}

void paintLandscape() {
  noStroke();
  scale(1.8);
  if (Blur) tint(255, 20); // Apply transparency without changing color
  else noTint(); 

  for ( int x = 3; x < TailleX-5; x++) {
    beginShape(QUADS);
    for ( int y = 3; y < TailleY-5; y++) {
      if (Couleur) {
        // b = hm[x][y] * 8;
        b = hm[x][y] * Facteur;
        // if ((b >= 0) & (b < 256)) fill(Palette256[int(b)]);
        b = max(min(b, 255), 0);
        fill(Palette256[int(b)]);
      }
      // else fill((hm[x][y] *12), (hm[x][y] * 12), (hm[x][y] * 12));
      // else fill((hm[x][y] *8), (hm[x][y] * 8), (hm[x][y] * 8));
      else fill((hm[x][y] * Facteur));
      vertex(x     - TailleXdemi, y     - TailleYdemi, hm[x]  [y]);
      vertex(x + 1 - TailleXdemi, y     - TailleYdemi, hm[x+1][y]);
      vertex(x + 1 - TailleXdemi, y + 1 - TailleYdemi, hm[x+1][y+1]);
      vertex(x     - TailleXdemi, y + 1 - TailleYdemi, hm[x]  [y+1]);
    }
    endShape();
  }
}


void keyPressed() {
  if ( key == 'd' || key == 'D' ) Image = "D";    // Defaut
  else if ( key == 'e' || key == 'E' ) Image = "E";
  // else if ( key == 'r' || key == 'R' ) Image = "R";
  else if ( key == 'b' || key == 'B' ) Blur = !Blur;
  else if ( key == 'y' || key == 'Y' ) CoucheInverse = !CoucheInverse;
  else if ( key == 'i' || key == 'I' ) Image = "I";
  else if ( key == 'h' || key == 'H' ) Image = "H";
  else if ( key == 'v' || key == 'V' ) Visu = !Visu;
  else if ( key == 'z' || key == 'Z' ) {
    Zoom      = !Zoom;
    if (Zoom) {
      x1 = -320;
      y1 = -240;
      x2 = 1280;
      y2 = 960;
    } else {
      x1 = 0;
      y1 = 0;
      x2 = width;   //      x2 = 640;
      y2 = height;  //      y2 = 480;
    }
  } else if ( key == 'c' || key == 'C' ) Couleur      = !Couleur;
  else if ( key == 's' || key == 'S' ) Sauve = true;
  else if ( key == 'n' || key == 'N' ) {
    Miroir = !Miroir; 
    Kinect.setMirror(Miroir);
    // Kinect.enableDepth();
  } else if ( key == '4' ) {
    QBlur = QBlur - 5;
    QBlur = max (QBlur, 0);
    println("QBlur = " + QBlur);
  } else if ( key == '6' ) {
    QBlur = QBlur + 5;
    QBlur = min (QBlur, 100);
    println("QBlur = " + QBlur);
  } else if ( key == '2' ) {
    Facteur = Facteur / 1.2;
    Delta = Delta + 1;
    println("Facteur = " + Facteur);
  } else if ( key == '8' ) {
    Facteur = Facteur * 1.2;
    Delta = Delta - 1;
    println("Facteur = " + Facteur);
  } else if ( key == '1' ) CalculPalette256(1); 
  else if ( key == '3' ) CalculPalette256(3); 
  else if ( key == '5' ) CalculPalette256(5); 
  else if ( key == '7' ) CalculPalette256(7); 
  else if ( key == '9' ) CalculPalette256(9); 
  else if ( key == '0' ) CalculPalette256(0); 
  else if ( key == 'g' || key == 'G' ) CalculInversePalette256();
  else if ( key == 'w' || key == 'W' ) EcouteVoix();
  if (key == CODED) {
    if (keyCode == UP) {
      Dy1 = Dy1 + 10;
      println("Dy1 = " + Dy1);
    } else if (keyCode == DOWN) {
      Dy1 = Dy1 - 10;
      println("Dy1 = " + Dy1);
    } else if (keyCode == LEFT) {
      Dx1 = Dx1 - 10;
      println("Dx1 = " + Dx1);
    } else if (keyCode == RIGHT) {
      Dx1 = Dx1 + 10;
      println("Dx1 = " + Dx1);
    }
  }
}

void FinOuverture() {
  // minim = new Minim(this);
  // player = minim.loadFile(NomFichierAudio, 1024);
  LecteurAudio[Voix] = minim.loadFile(NomFichierAudio, 1024);
  println(LecteurAudio[Voix].length() / 1000 + " secondes");
  nomVoix[Voix] = DebutNomFichier;
  println("nomVoix[" + Voix + "] = " + nomVoix[Voix]); 
  println();
  // FichierOuvert[0] = true;
  xmax = 0;
  IndexXML = -1;
  // Lissage();
  // LecteurAudio[Voix].setPan(-1); // Pan is not supported! Processing 2.2.1 MacOSX.10  minim 3.0 BETA
  // Pan OK Processing 2.0.3 MacOSX.6
  // LecteurAudio[Voix].setVolume(0.1); // Volume is not supported!
  // LecteurAudio[Voix].setBalance(-1); // Balance is not supported!
  // LecteurAudio[Voix].setGain(-20); // OK!
  // LecteurAudio[Voix].play();
  TempsPause = millis();
}

void Ouverture1Fois(int i) { // i = 0 .. 11
  if (!FichierOuvert[i]) {
    FichierOuvert[i] = true;
    Ouverture(TableNomFichier[i], i);
    println("i = " + i + "    " + TableNomFichier[i]);
  }
}

void LecteurFragmentAudio(int Voix, int min, int max) { // min max en ms  
  // if (!LecteurAudio[Voix].isPlaying()) {
  // LecteurAudio[Voix].unmute();
  LecteurAudio[Voix].play(min);
  TempsVoix[Voix] = millis() + max;
  // }
}

int TextX(int x) { // TextX(Voix % 4)
  // return width / 2 - int(TailleCarre * ( 1.5 - x));
  int resultat;
  if (NVoix == 6) resultat = width / 2 - int(TailleCarreX * ( 1 - x));
  else  resultat = width / 2 - int(TailleCarreX * ( 1.5 - x));
  return resultat;
}

int TextY(int y) { // TextY(Voix / 4)
  // return height - int(TailleCarre * ( 2.5 - y));
  int resultat;
  if (NVoix == 6) resultat = height - int(TailleCarreY * ( 1.5 - y));
  else  resultat = height - int(TailleCarreY * ( 2.5 - y));
  return resultat;
}

void CalculPalette256(int p) { // p = 1 3 5 7 9 0
  if (p == 1) for (int i=0; i<256; i++) Palette256[i] = color(i, 0, 0);
  else if (p ==3) {
    for (int i=0; i<64; i++) {
      Palette256[i]     = color(0, 0, i * 4);           // Black to blue
      Palette256[i+64]  = color(i * 4, i * 4, 252);     // blue to white
      Palette256[i+128] = color(252, 252, (64 - i) * 4);// white to Yellow, 
      Palette256[i+192] = color(252, (126 - i) * 2, 0); // Yellow to Orange
    }
  } else if (p ==5) for (int i=0; i<256; i++) Palette256[i] = color(i);
  else if (p ==7) for (int i=0; i<256; i++) Palette256[i] = color(255, i, i);
  else if (p ==9) for (int i=0; i<256; i++) Palette256[i] = color(i, i / 2, i / 2);    
  else if (p ==0) for (int i=0; i<256; i++) Palette256[i] = color(128 + (i / 2), i / 2, i / 2);
}

void CalculInversePalette256() {
  int p;
  for (int i=0; i<128; i++) {
    p = Palette256[i];
    Palette256[i] = Palette256[255 - i];
    Palette256[255 - i] = p;
  }
}

void EcouteVoix() {  // keyPressed w ou W
  LecteurAudio[1].play();
  println("W EcouteVoix TempsVoix[1] = " + TempsVoix[1]);
}

//boolean sketchFullScreen() {
//  println("Plein Ecran = " + PleinEcran);
//  return PleinEcran;
//}

//void stop() {
//  println("FIN");
//  // always close Minim audio classes when you are done with them
//  for (Voix = 0; Voix < NVoix; Voix++) LecteurAudio[Voix].close();
//  minim.stop();
//  super.stop();
//}

