// "Urn is a random without duplication"x
// https://processing.org/discourse/beta/num_1233425711.html


class Urn {

  int maximum; //max array size
  int[] urn;
  int index; //current level

  Urn(int _maximum) {
    maximum = _maximum;
    urn = new int[_maximum];
    for (int i = 0; i < maximum; i++) urn[i] = i;      
    reset();
  }

  void reset() {    
    index = maximum - 1;
  }

  int update() {
    if (index < 0) return -1;
    int randomIndex = floor(random(index));
    int returnValue = urn[randomIndex];
    urn[randomIndex] = urn[index];      
    urn[index] = returnValue;
    index--;
    return returnValue;
  }
}

